<?php
/*
 * LimeSurvey SimpleSAMLphp autentication
 * Copyright (C) 2009 - SURFnet - www.surfnet.nl
 * All rights reserved.
 * License: GNU/GPL License v2 or later, see LICENSE.php
 *
 * This config implements the use of simplesamlphp (http://rnd.feide.no/simplesamlphp/)
 * for authentication of users using SAML
 *
 * SAML authentication is implemented using the already available '$useWebserverAuth' variable.
 *
 * Modified by mmacinko@srce.hr , www.srce.hr , 2010.
 */


// This section is copied from config-defaults.php

// Enable delegation of authentication to the webserver.
$useWebserverAuth = true;

// Enable this if you want to automatically create users authenticated by the webserver in LS
$WebserverAuth_autocreateUser = true;


if (strpos ($_SERVER['REQUEST_URI'], '/admin/') !== false) {


// Include simpleSAMLcodebase
require_once('/var/www/simplesamlphp/lib/_autoload.php');


// Use the default sp setting as defined in simplesamlphp
$as = new SimpleSAML_Auth_Simple('default-sp');

// force authentication against remote IdP
$as->requireAuth();

// Define logout URL
if ($_GET['action']=="logout")
{
$as->logout('http://'.$_SERVER['HTTP_HOST'].'/limesurvey/admin');
}

// Get attributes provided by the IdP
$attributes = $as->getAttributes();

// Get a unique ID for the user.
$user_id = $attributes['hrEduPersonUniqueID'][0];

// Allow access only to djelatnik 
if ($attributes['hrEduPersonAffiliation'][0] != 'djelatnik')
{
die('Nemate pravo pristupa');
}


// Allow access only from srce.hr
if ($attributes['hrEduPersonHomeOrg'][0] != 'srce.hr')
{
die('Nemate pravo pristupa');
}

// Set the $user_id in the server scope; this allows limesurvey to detect the user is already authenticated
$_SERVER['REMOTE_USER'] = $user_id;

// Use the hook_get_autouserprofile funciton to provision users on the fly
function hook_get_autouserprofile($user_id)
{

  // Define some layout and formatting defaults for the user
  $layoutDefaults = Array(
                        'lang' => 'hr',
                        'htmleditormode' => 'inline',
                        'templatelist' => 'default,basic,MyOrgTemplate');

  // Get roles from the groupmanager to determine roles & rights
  $userRights = getGroupRoles($user_id);


  // Get the federation attributes and map these to limesurvey attributes
  global $as;

  $attributes = $as->getAttributes();
  $user_name = $attributes['hrEduPersonUniqueID'][0];

  // Use email attribute to fill email settings; note that an email adress is required for limesurvey
  $user_email = $attributes['mail'][0];
  $puno_ime = $attributes['cn'][0];
  $userAttributes =  Array(
                        'full_name' => $puno_ime,
                        'email' => $user_email);

  return array_merge($userAttributes, $userRights, $layoutDefaults)     ;
}

// This is a placeholder function that can query a groupmanager such as Grouper (http://www.internet2.edu/grouper/)
// to determine the roles and set the rights of the user accordingly
function getGroupRoles($user_name) {

        return Array('create_survey' => 1,
                             'create_user' => 0,
                             'delete_user' => 0,
                             'superadmin' => 0,
                             'configurator' =>0,
                             'manage_template' => 0,
                             'manage_label' => 0);

 }
?>
